.386p
_TEXT segment byte public use16 'CODE'
	assume	cs:_TEXT

INITSEG  = 9000H
SETUPSEG = 9020H
CMDLINESEG = 9900H

reserve_ds	dw	0
reserve_es	dw	0

gdt_48:
	dw	gdt_end - gdt - 1
	dw	0, 0		; gdt address(fill in later)
gdt:	
	dw	0, 0, 0, 0

gdt_ds	dw	0ffffh
	db	0h, 0h, 0h
	db	92h
	db	0h, 0h

gdt_es	dw	0ffffh
	db	0h, 0h, 10h
	db	92h
	db	0h, 0h

gdt_reserve:
	dw	0ffffh
	db	0h, 0h, 0h
	db	92h
	db	0h, 0h
gdt_end:


;;
;;	exec_setup(char *setup, short setup_size, long kernel_addr, long kernel_size, char *cmdline);
;;
public	_exec_setup
_exec_setup	proc	far
	push	bp
	mov	bp, sp

	push	ax
	push	bx
	push	cx
	push	ds
	push	es
	push	si
	push	di

	mov	cs:reserve_ds, ds
	mov	cs:reserve_es, es


	;; put 'ret' to bios entry
	mov	ax, 0fffbh
	mov	es, ax
	mov	al, 0cbh	; lret
	mov	byte ptr es:01eh, al


	;; transfer setup
	mov	si, [bp+4]	; si = setup
	mov	cx, [bp+6]	; cx = size
	mov	ax, INITSEG
	mov	es, ax
	xor	di, di
	cld
	rep movsb

	;; transfer cmdline
	mov	si, [bp+16]	; si = cmdline
	mov	cx, 256		; cx = 256 byte
	mov	ax, CMDLINESEG
	mov	es, ax
	xor	di, di
	cld
	rep movsb

	;; transfer bzImage
	;; make gdt
	mov	eax, [bp+12]	; kernel size (byte)
	shr	eax, 12		; eax= kernel_size/4096
	inc	eax
	mov	bx, ax
	shr	eax, 16
	or	al, 080h	; G bit on
	mov	cs:gdt_ds, bx
	mov	byte ptr cs:[gdt_ds+6], al
	mov	cs:gdt_es, bx
	mov	byte ptr cs:[gdt_es+6], al
	mov	eax, [bp+8]	;  kernel address (physical)
	and	eax, 00ffffffh
	or	eax, 92000000h	; typdata
	mov	dword ptr cs:[gdt_ds+2], eax

	mov	eax, [bp+8]	;  kernel address (physical)
	shr	eax, 24
	mov	byte ptr cs:[gdt_ds+7], al

	; fill gdt address
	xor	eax, eax
	mov	ax, cs
	shl	eax, 4
	add	eax, offset gdt
	mov	dword ptr cs:gdt_48+2, eax

	lgdt	fword ptr cs:gdt_48


	mov	ecx, [bp+12]	; kernel size (byte)

	; go to protect mode
	cli
	mov	eax, cr0
	or	eax, 1
	mov	cr0, eax
	jmp	flush_q3
flush_q3:

	mov	ax, 08h
	mov	ds, ax
	mov	ax, 10h
	mov	es, ax

	;; move bzImage
	xor	edi, edi
	xor	esi, esi
	cld
	db	66h, 67h	; 32bit address
	rep	movsb

	;; restore es,ds
	mov	ax, 18h
	mov	ds, ax
	mov	es, ax

	; return to real mode
	mov	eax, cr0
	and	eax, 0ffffffeh
	mov	cr0, eax
	jmp	flush_q4
flush_q4:

	mov	ds, cs:reserve_ds
	mov	es, cs:reserve_es

;	mov	al,0ffH
;	out	12H,al
;	out	02H,al
;
;	xor	al,al
;	out	20H,al
;
;	mov	ax,INITSEG
;	mov	ss,ax
;	mov	sp,8000H

	push	word ptr SETUPSEG
	push	word ptr 0000h
	ret			; far return
_exec_setup	endp

; terminate_ems
EMM_ID		db	'EMMXXXX0'
EMM386_ID	db	'EMM386'
EMM386_ENTRY	dd	0
EMM386_OFF = 0104H
;

	public	_terminate_ems
_terminate_ems proc near
	push	ds
	push	es
	pushad
	mov	ah, 02h		; ah=02h : Execute Terminate Handle
	int	0ach		; Call Terminate BIOS
	cld
	xor	ax,ax
	mov	ds,ax
	mov	si,67h*4+2	; int 67h
	lodsw
	mov	ds,ax		; segment -> DS
	push	cs
	pop	es
	mov	si,0ah		; device name offset
	mov	di,offset EMM_ID
	mov	cx,8
	repe	cmpsb		; exist emm driver ?
	jz	EM01
	jmp	EM03
EM01:
	mov	si,014h
	mov	di,offset EMM386_ID
	mov	cx,6
	repe	cmpsb		; emm386.exe ?
	jz	EM02
	jmp	EM03
EM02:
	mov	si,012h		; emm386 device entry
	lodsw
	mov	word ptr cs:EMM386_ENTRY,ax
	mov	ax,ds
	mov	word ptr cs:EMM386_ENTRY+2,ax

	in	al,02h		; Master PIC status
	mov	cl,al
	in	al,12h		; Slave  PIC status
	mov	ch,al
	push	cx		; Save PIC status

	mov	al,0ffh
	out	02h,al		; Mask Master PIC
	out	12h,al		; Mask Slave  PIC

	mov	ax,EMM386_OFF	; EMM386 OFF
	mov	si,offset cs:EMM386_ENTRY
	call	dword ptr cs:[si]

	pop	ax		; pop PIC status
	out	02h,al		; Restore Master PIC
	mov	al,ah		;
	out	12h,al		; Restore Slave  PIC
EM03:
	popad
	pop	es
	pop	ds
	ret
_terminate_ems endp

_TEXT	ends
	end
